/*
 * SuperOfferSupplierHandler.java
 *
 * Created on 17 de agosto de 2004, 13:31
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Log;
import com.fenalco.entities.SuperOffer;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet se encarga de realizar las operaciones necsarias para actualizar
 * los datos de una superoferta en la base de datos.
 * 
 * @author andres
 */
public class SuperOfferSupplierHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Crea un objeto del tipo <CODE>SupperOffer</CODE> con los datos del
	 * formulario de actualización de la superoferta y luego hace un llamado al
	 * método <CODE>saveData</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				SuperOffer superOffer = new SuperOffer(new Integer(request
						.getParameter("superOfferId")).intValue());
				superOffer.setDescription(request.getParameter("description"));
				//superOffer.setImageUrl(request.getParameter("imageUrl"));
				superOffer.setImageUrl("/images/superoffer/" + superOffer.getId()
						+ ".gif");
	
				Transaction t = new Transaction();
				superOffer.update(t);
				url = "/proveedor/superofertasproveedor";
				if( !t.execute() )
				{
					//Fallo al actualizar la superoferta
					message = MessageBuilder.buildMessage(7);
				}
				else
				{
					//Todo OK
					//La superoferta fue actualizada
					message = MessageBuilder.buildMessage(4);
					
					//registro en el Log la actualización de la superoferta
	                try
	                {
	                    Transaction t1 = new Transaction( );
	                    Log l = new Log( );
						User user = ( User )session.getAttribute( "user" );
	                    String userId = user.getLogin();
	                    String numberId = user.getIdentificationNumber();
	                    String externalUser = "";
	                    User callcenter = ( User )session.getAttribute( "callcenter" );
	                    String description = "Modificación de la superoferta " + superOffer.getDescription();
	                    if( callcenter != null )
	                    {
	                        externalUser = callcenter.getLogin();
	                    }
						l.saveData(userId, numberId, 46, description, externalUser, t1 );
	                    t1.execute();
	                }
	                catch( Exception ex )
	                {
	                    System.out.println( "Error guardando el Log." );
	                }
	
				}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}